/*
 * yjs
 * 2008-02-16
 */
;(function($) {
	$.utils = $.utils || {}; 
	$.extend($.utils, {
		version : "1.0.0",		
		autoNext : function(after){			
        	var $inp = $(this).find(":input:visible");
        	$inp.bind("keydown", function (e){
            	var key = e.which;
           	 	if(key == 13) {
                	e.preventDefault();
                	var nxtIdx = $inp.index(this) + 1;
                	if(after){
                		after(this);
                	} 
                	$(":input:visible:eq(" + nxtIdx + ")").focus();
            	}
       		});			
		},
		getSelectValues : function(){
			var result = "";
			$("option",this).each(function(){
				if($(this).val() != ""){
					result += result == "" ? $(this).val() : "|" + $(this).val();
				}
			});
			return result;
		},
		getValues : function(filter){
			var results = {};
			var objs = $(this).find(":input");
			if(filter){
				objs = objs.filter(filter);
			}
			objs.each(function(){
				var self = $(this);
				var type = self.attr("type").toLowerCase();	
				if(type == "button" || type == "image" || type == "submit" || type == "reset") return;				
				if(type == "radio" && self.attr("checked") != true) return;						
				if(!self.attr("id") && !self.attr("name")) return;
				var key = self.attr("id") ? self.attr("id") : self.attr("name");
				var val = self.val();				
				if(type == "checkbox"){
					val = self.attr("checked") ? "1" : "0";
				}
				results[key] = val;
			});				
			return results;	
		},
		setValues : function(data){
			for(var key in data){
				var value = data[key];				
				(this).find(":input[name=" + key + "]").each(function(){
					var type = $(this).attr("type");
					var ltype = type.toLowerCase();					
					if(ltype == "checkbox"){
						$(this).attr("checked",(value && value != '0') ? true : false);
					}else if(ltype == "radio"){
						if($(this).val()==value){ $(this).attr("checked",true);}
					}else{		
						if(value== null){
							value = "";
						}				
						$(this).val(value);	
					}					
				});				
			}
		},
		loadForm:function(url,data,callback,init){
			if($(this).data("url") != url){				
				$(this).load(url,{rand:Math.random()},function(){
					$(this).data("url",url);
					$(this).setValues(data);
					if(typeof init == 'function'){init(this);}
					if(typeof callback == 'function'){callback(this);}
				});
			}else{
				$(this).setValues(data);
				if(typeof callback == 'function'){callback(this);}
			}
		},
		reLoadForm:function(url,data,callback,init,param){
			$(this).empty();
			if(!param){param = {};};		
			param["rand"] = Math.random();
			$(this).load(url,param,function(){				
				$(this).setValues(data);
				if(typeof init == 'function'){init(this);}
				if(typeof callback == 'function'){callback(this);}
			});			
		},
		initOptions:function(initString,sv){
			if(!$(this).is("select")){
				return;
			}
			$(this).empty().css("width","99%");
			var optionsArr = initString.split(",");
			for(var i=0;i<optionsArr.length;i++){
				var optionArr = optionsArr[i].split(":");	
				var isSelect = (sv == optionArr[0]) ? " selected" : "";
				$(this).append("<option value='" + optionArr[0] + "' " + isSelect + ">" + optionArr[1] + "</option>");
			}
		},
		maximizeHeight : function(options){
			var def = {min:null,max:null,margin:0};
			if(options){
				$.extend(def,options)
			}			
			$(this).each(function(){
				var self = $(this);				
				var siblings = self.siblings("*:visible");
				var allHeight = self.parent().height();
				siblings.each(function(){
					allHeight = allHeight - $(this).height();
				});
				if(def.min !== null){
					if(allHeight<min){allHeight = def.min}
				}
				if(def.max !== null){
					if(allHeight>max){allHeight = def.max}
				}
				self.height(allHeight-def.margin);
			});
		},
		widths:function(){
			var widths = "";
			$(this).find("tr:first").children().each(function(){
				widths += widths=="" ? $(this).width() : "_"+$(this).width();
			})
			return widths;
		},
		enable_change_confirm:function(msg){
			var _f = this;    
			$(":text, :password, textarea,:hidden", this).each(function() {      
        		$(this).attr('___value', $(this).val());         		
    		});    
    
			$(':checkbox, :radio', this).each(function() {      
				var _v = this.checked ? 'on' : 'off';      
				$(this).attr('___value', _v);      
			});    
			$('select', this).each(function() {      
				$(this).attr('___value', this.options[this.selectedIndex].value);      
			});			   
		    window.onbeforeunload = function() {  		    	
				if($(_f).attr("___changed") || is_form_changed(_f)) {      
					return msg;
				}      
			}      
		},
		set_change_true:function(){
			$(this).attr("___changed",true);
		},
		reset_change_confirm:function(){
			var _f = this;    
			$(":text, :password, textarea,:hidden", this).each(function() {      
        		$(this).attr('___value', $(this).val());      
    		});    
    
			$(':checkbox, :radio', this).each(function() {      
				var _v = this.checked ? 'on' : 'off';      
				$(this).attr('___value', _v);      
			});    
			$('select', this).each(function() {      
				$(this).attr('___value', $(this).val());      
			});			 
		},
		is_change_true:function(){
			var _f = this;
			return $(_f).attr("___changed") || is_form_changed(_f);
		}		
	});
	function is_form_changed(f) {      
		var changed = false;      
		$(':text, :password,:hidden,textarea', f).each(function() {    			
	        var _v = $(this).attr('___value');  	       
			if(typeof(_v) == 'undefined'){
				return;
			}
			if(_v != $(this).val()){ 				
				changed = true;   				
			}
		});      
	    
		$(':checkbox, :radio', f).each(function() {      
			var _v = this.checked ? 'on' : 'off';    
			if(_v != $(this).attr('___value')){
				changed = true;    				
			}
		});      
	  
		$('select', f).each(function() {      
			var _v = $(this).attr('___value');  			
			if(typeof(_v) == 'undefined'){
				return;    
			}
			if(_v != this.options[this.selectedIndex].value){				
				changed = true; 				
			}
		});      
		return changed;      
	}    
	$.extend({
		checkParameters:function(params,rules){
			//var checks="unique,"
			var rv = {};
			rv.result = true;
			rv.message = "";				
			for(var i=0;i<rules.length;i++){		
				var item = rules[i];				
				var field = item.field;
				var msg = item.msg;
				var rule = item.rule;						
				for(var j=0;j<rule.length;j++){
					var check = rule[j];
					if(check == "unique"){
						if(!params[field] || params[field] == ""){
							rv.result = false;
							if(msg[check]){
								rv.message += msg[check]+"\n";
							}else{
								rv.message += "ֶΡ" +field+ "Ϊգ\n";
							}								
						}
					}
				}
			}	
			return rv;
		},
		openWindow : function(url,width,height,title){
			var w = $(window.top.screen).attr("availWidth");
			var h = $(window.top.screen).attr("availHeight")-40;
			var left = (w - width)/2;			
			var top = (h - height)/2;			
			var param ="left=" + left + ",top=" + top + ",width="+width + ",height="+height+ ",resizable=yes,scrollbars=yes";
			if(!title){
				title = '';
			}
			var ow = window.open(url,title,param);
			ow.focus();
		},
		openFullWindow:function(url,title){
			var w = $(window.top.screen).attr("availWidth")*0.9;
			var h = $(window.top.screen).attr("availHeight")*0.8;			
			var param ="resizable=yes,scrollbars=yes,right=0,top=40,width="+w + ",height="+h;
			var newwin=window.open(url,title,param)			
			newwin.focus();
		},
		toDescString : function(obj){		
			if(obj === null) return "null";
			if(obj === undefined) return "undefined";	
			if(typeof obj == "string") return "'" + obj + "'";			
			if(jQuery.isArray(obj)){			
				var result = "[";
				var sp = "";
				for(var i=0;i<obj.length;i++){					
					result += sp + $.toDescString(obj[i]);
					sp = ",";
				}
				result += "]";		
				return result;		
			}			
			if(typeof obj == "object"){
				var result = "{";
				var sp = "";				
				for(var key in obj){
					result += sp + key + ":"+  $.toDescString(obj[key]);					
					sp = ",";
				}
				result += "}";
				return result;		
			}
			return obj.toString();
		},
		round : function(number,dv){
			var t=1; 
			for(;dv>0;t*=10,dv--); 
			for(;dv<0;t/=10,dv++); 
			return Math.round(number*t)/t;		
		},		
		showAjaxAction: function(options){ 			
			options = $.extend({img:false,text:'loading...'},options);			
			if($("#my_ajax_view").length == 0){
				var w = $(window).width();
				var h = $(window).height();				
				var $el = $("<div id='my_ajax_view'></div>").appendTo(document.body).css({
					position:"absolute",
					top:0,
					left:0,
					width: w,
					height:h,
					"z-index":99998,					
					background:"#AAAAAA repeat-x scroll 50% 50%",
					opacity:0.3,
					display:"none"
				});						
				($.fn.bgiframe && $el.bgiframe());
				
				$center = $("<div id='my_ajax_view_center'></div>").appendTo(document.body);				
				if(options.img){
					$center.append($("<div></div>").append("<img src='" + options.img + "'/>"));				
				}				
				$center.append($("<div></div>").text(options.text));
				$center.css({
					position:"absolute",
					top:(h - $center.outerHeight())/2,
					left:(w-$center.outerWidth())/2,
					"z-index":99999,
					"background-color":"#FFF",
					display:"none"
				});				
				
				$el.ajaxStart(function(){
					var w = $(window).width();
					var h = $(window).height();
					$(this).css({
						width: w,
						height:h
					}).show();
					$("#my_ajax_view_center").css({
						top:	(h - $("#my_ajax_view_center").outerHeight())/2,
						left:	(w - $("#my_ajax_view_center").outerWidth())/2		  
					}).show();
				}).ajaxStop(function(){
					$(this).hide();
					$("#my_ajax_view_center").hide();
				}).ajaxError(function(){
					$(this).hide();
					$("#my_ajax_view_center").hide();
				});
			}			
		}
	});
	$.fn.extend($.utils);
})(jQuery);


;(function($){ 
    var ajax=$.ajax;
    $.ajax=function(s){
        var old=s.error;
        s.error=function(xhr,status,err){			
            var errMsg = xhr.responseText;
			if(!old){
				 alert(errMsg);
			}else{
				old(xhr,status,errMsg||err);
			}          
        }
        ajax(s);
    }
})(jQuery); 